//TODO write routines for irrigation timing
//finalize intervals for real-life application


#include <Servo.h>
 
int probePower = 7;
int probeSensor = 0;
int lightSense = 6;
 
Servo lightServo;
int lightServoPos = 0;
 
void setup() {
  Serial.begin(9600);
  delay(10);
  pinMode(probePower, OUTPUT);
  pinMode(lightSense, INPUT);
 
  lightServo.attach(5);
  endLight();
}
int lightLoopCount = 0;
bool lightOn = false;
int lightSum = 0;
long avgMoisture = 0;
int moistureLoopCount = 0;
 
void loop() {

  delay(500); 
 
  digitalWrite(probePower, HIGH);
  int moistVal = analogRead(probeSensor);
  avgMoisture += moistVal;
  Serial.print("Moisture Content:  ");
  Serial.println(moistVal);
 
  Serial.print(F("\nSending moisture val "));
  Serial.print(moistVal);
  Serial.print("...");
   
  // turn off power to sensor and wait to take another reading
  digitalWrite(probePower, LOW);
 
  int lightVal = digitalRead(lightSense);
  lightSum += lightVal;
  Serial.print(F("\nSending photocell val "));
  Serial.print(lightVal);
  Serial.print("...");

 
  if(lightLoopCount == 14) {
    lightLoopCount = 0;
    if (lightSum > 7) {
      triggerLight();
      lightOn = true;    
     }
     lightSum = 0;
  }
  if(lightLoopCount == 12 && lightOn) {
    endLight();
    lightOn = false;
  }
 
  if(moistureLoopCount == 14) {
    moistureLoopCount = 0;
    if (avgMoisture < 600.0) {
      triggerIrrigation();
    }
     avgMoisture = 0.0;
  }
 
  lightLoopCount++;
  moistureLoopCount++;
}
 
void triggerIrrigation() {
  Serial.println("Started irrigation");
}
 
void endIrrigation() {
 //TODO
}
 
void triggerLight() {
  Serial.println("Light on");
  myservo.write(65);
  delay(1000);
//  for (lightServoPos = 180; lightServoPos >= 0; lightServoPos-=1) {
//    lightServo.write(lightServoPos);
//    delay(15);
//  }
  // lightServoPos = 0;
  // lightServo.write(lightServoPos);

}
 
void endLight() {
  Serial.println("Light off");
  myservo.write(90);
  delay(1000);
//  for (lightServoPos = 0; lightServoPos <= 180; lightServoPos+=1) {
//    lightServo.write(lightServoPos);
//    delay(15);
//  }
 // lightServoPos = 180;
  // lightServo.write(lightServoPos);
 
}
